def lunar_addition(a, b):
    a, b = a.zfill(max(len(a), len(b))), b.zfill(max(len(a), len(b)))
    return "".join(str(max(int(x), int(y))) for x, y in zip(a, b))

def lunar_multiplication(a, b):
    a, b = a[::-1], b[::-1]
    intermediate_results = []

    for i, digit_a in enumerate(a):
        row_result = []
        for digit_b in b:
            row_result.append(str(min(int(digit_a), int(digit_b))))
        intermediate_results.append("".join(row_result[::-1]) + "0" * i)

    result = "0"
    for partial in intermediate_results:
        result = lunar_addition(result, partial.zfill(len(result)))

    return result

def main():
    a = input().strip()
    b = input().strip()
    lunar_sum = lunar_addition(a, b)
    lunar_product = lunar_multiplication(a, b)
    print(lunar_sum, lunar_product)
    

if __name__ == "__main__":
    main()