#include <bits/stdc++.h>
using namespace std;
const int MOD = 998244353;

vector<int> left_min(vector<int>& a) {    // Гистограмма левый минимум
    stack<int> st;
    size_t n = a.size();
    vector<int> ans(n);  // храним индексы
    for (size_t i = 0; i < n; ++i) {
        while(!st.empty() and a[st.top()] > a[i]) {
            st.pop();
        }
        if (st.empty()) {
            ans[i] = -1;
        }
        else {
            ans[i] = st.top();
        }
    }
    return ans;

}
vector<int> min_k(vector<int>& a, size_t n, int k) {
    vector<int> ans;
    deque<int> dq;
    for (size_t i = 0; i < n; ++i) {
        while(!dq.empty() and a[dq.back()] >= a[i]) {
            dq.pop_back();
        }
        dq.push_back(i);
        if (dq.front() <= i - k) {
            dq.pop_front();
        }
        if ((i >= k - 1)){
            ans.push_back(a[dq.front()]);
        }
    }
    return ans;
}
vector<int> right_min(vector<int>& a) {
    stack<int> st;
    size_t n = a.size();
    vector<int> ans(n);
    for (int i = n-1; i >= 0; --i) {
        while(!st.empty() and a[st.top()] >= a[i]) {
            st.pop();
        }
        if (st.empty()) {
            ans[i] = n;
        }
        else {
            ans[i] = st.top();
        }
        st.push(i);
    }
    return ans;
}
bool cube(const vector<int>& arr) {
    int sum1 = arr[0] + arr[5]; 
    int sum2 = arr[1] + arr[4];
    int sum3 = arr[2] + arr[3];
    return (sum1 == sum2 and sum2 == sum3);
}
int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> graph(n + 1);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    vector<pair<int, int>> o(k);
    for (int i = 0; i < k; ++i) {
        cin >> o[i].first >> o[i].second;
    }
    set<int> st;

    for (const auto& guard : o) {
        int x = guard.first;
        int y = guard.second;
        queue<pair<int, int>> q;
        vector<bool> used(n + 1, false);
        q.push({x, 0});
        used[x] = true;
        while (!q.empty()) {
            int cur = q.front().first;
            int s = q.front().second;
            q.pop();
            if (s <= y) {
                st.insert(cur);
            }
            for (int neighbor : graph[cur]) {
                if (!used[neighbor] and s + 1 <= y) {
                    used[neighbor] = true;
                    q.push({neighbor, s + 1});
                }
            }
        }
    }
    cout << st.size() << endl;
    if (!st.empty()) {
        vector<int> res(st.begin(), st.end());
        sort(res.begin(), res.end());
        for (int i = 0; i < res.size(); ++i) {
            cout << res[i] << " ";
        }
    }
    else {
        cout << endl;
    }
}